/* omega (c) 1987,1988,1989 by Laurence Raphael Brothers */
/* ofile.c */
/* functions with file access in them. Also some direct calls to
   curses functions */

#include "oglob.h"
#ifdef MSDOS
#include "curses.h"
#else
#include <curses.h>
#include <sys/types.h>
#include <unistd.h>
#include <sys/file.h>
#include <sys/fcntl.h>
#include <errno.h>
#endif

FILE *checkfopen(filestring,optionstring)
char *filestring,*optionstring;
{
  FILE *fd;
  char response;

  change_to_game_perms();
  fd = fopen(filestring,optionstring);
  clearmsg();
  while (fd == NULL) {
    print3("Warning! Error opening file:");
    nprint3(filestring);
    print1(" Abort or Retry? [ar] ");
    do response = mcigetc(); while ((response != 'a') && (response != 'r'));
    if (response == 'r') fd = fopen(filestring,optionstring);
    else {
      print2("Sorry 'bout that.... Saving character.");
      morewait();
      save(TRUE);
      endgraf();
      exit(0);
    }
  }
  return(fd);
}

void commandlist()
{
  FILE *fd; 
  strcpy(Str1,OMEGALIB);
  if (Current_Environment == E_COUNTRYSIDE)
    strcat(Str1,"ohelp13.txt");
  else strcat(Str1,"ohelp12.txt");
  fd = checkfopen(Str1,"r");
  showfile(fd);
  fclose(fd);
  clear();
  refresh();
  xredraw();
}


void user_intro()
{
  FILE *fd; 
  strcpy(Str1,OMEGALIB);
  strcat(Str1,"ointro.txt");
  fd = checkfopen(Str1,"r");
  showfile(fd);
  fclose(fd);
  clear();
  refresh();
  xredraw();
}

void show_license()
{
  FILE *fd; 
  strcpy(Str1,OMEGALIB);
  strcat(Str1,"olicense.txt");
  fd = checkfopen(Str1,"r");
  showfile(fd);
  fclose(fd);
  clear();
  refresh();
  xredraw();
}



void abyss_file()
{
  FILE *fd; 
  strcpy(Str1,OMEGALIB);
  strcat(Str1,"oabyss.txt");
  fd = checkfopen(Str1,"r");
  showfile(fd);
  fclose(fd);
  clear();
  refresh();
}




void inv_help()
{
  FILE *fd; 
  strcpy(Str1,OMEGALIB);
  strcat(Str1,"ohelp3.txt");
  fd = checkfopen(Str1,"r");
  showfile(fd);
  fclose(fd);
  clear();
  refresh();
  xredraw();
}



void combat_help()
{
  FILE *fd; 
  strcpy(Str1,OMEGALIB);
  strcat(Str1,"ohelp5.txt");
  fd = checkfopen(Str1,"r");
  showfile(fd);
  fclose(fd);
  clear();
  refresh();
  xredraw();
}




void cityguidefile()
{
  FILE *fd;
  strcpy(Str1,OMEGALIB);
  strcat(Str1,"oscroll2.txt");
  fd = checkfopen(Str1,"r");
  showfile(fd);
  fclose(fd);
  clear();
  refresh();
  xredraw();
}


void wishfile()
{
  FILE *fd;
  strcpy(Str1,OMEGALIB);
  strcat(Str1,"oscroll3.txt");
  fd = checkfopen(Str1,"r");
  showfile(fd);
  fclose(fd);
  clear();
  refresh();
  xredraw();
}

void adeptfile()
{
  FILE *fd;
  strcpy(Str1,OMEGALIB);
  strcat(Str1,"oscroll4.txt");
  fd = checkfopen(Str1,"r");
  showfile(fd);
  fclose(fd);
  clear();
  refresh();
  xredraw();
}

void theologyfile()
{
  FILE *fd;
  strcpy(Str1,OMEGALIB);
  strcat(Str1,"oscroll1.txt");
  fd = checkfopen(Str1,"r");
  showfile(fd);
  fclose(fd);
  clear();
  refresh();
  xredraw();
}


void showmotd()
{
  FILE *fd;
  strcpy(Str1,OMEGALIB);
  strcat(Str1,"omotd.txt");
  fd = checkfopen(Str1,"r");
  showfile(fd);
  fclose(fd);
  clear();
  refresh();
}




/* display a file page at a time */
void showfile(fd)
FILE *fd;
{
  int c,d=' ';
  int x,y;
  clear();
  refresh();
  c = fgetc(fd);
  while ((c != EOF)&&((char) d != 'q')&&((char) d!=ESCAPE)) {
    getyx(stdscr,y,x);
    if (y > ScreenLength) {
      printw("\n-More-");
      refresh();
      d = wgetch(stdscr);
      clear();
    }
    printw("%c",(char) c);
    c = fgetc(fd);
  }
  if (((char) d != 'q')&&((char) d!=ESCAPE)) {
    printw("\n-Done-");
    refresh();
    getch();
  }
}    

void lock_score_file()
{
#ifndef MSDOS
    int lock, attempts, thispid, lastpid = 0;
    FILE *lockfile;

    strcpy(Str1,OMEGALIB);
    strcat(Str1,"omega.hi.lock");
    do
    {
	lock = open(Str1, O_CREAT|O_EXCL, 0600);	/* create lock file */
	if (lock < 0 && errno == EEXIST)
	{
	    lockfile = fopen(Str1, "r");
	    if (lockfile)
	    {
		fscanf(lockfile, "%d", &thispid);
		fclose(lockfile);
		if (thispid != lastpid)
		    attempts = 0;
		lastpid = thispid;
	    }
	    attempts++;
	    if (attempts > 10)	/* assume that lock file has been abandoned */
		unlink(Str1);	/* so we unlink it ourselves - ugly...	*/
	    else
		sleep(2);
	}
	else if (lock < 0)	/* oops - something very wrong */
	    return;
    } while (lock < 0);
    sprintf(Str1, "%d", getpid());
    write(lock, Str1, strlen(Str1));
    close(lock);
#endif
}

void unlock_score_file()
{
#ifndef MSDOS
    strcpy(Str1,OMEGALIB);
    strcat(Str1,"omega.hi.lock");
    unlink(Str1);
#endif
}

void showscores(display)
int display;
{
  FILE *fd;
  int i;

  lock_score_file();
  strcpy(Str1,OMEGALIB);
  strcat(Str1,"omega.hi");
  fd = checkfopen(Str1,"r");
  filescanstring(fd,Hiscorer);
  filescanstring(fd,Hidescrip);
#ifndef MSDOS
  fscanf(fd,"%d\n%d\n%d\n",&Hiscore,&Hilevel,&Hibehavior);
#else
  fscanf(fd,"%ld\n%d\n%d\n",&Hiscore,&Hilevel,&Hibehavior);
#endif
  filescanstring(fd,Chaoslord);
  fscanf(fd,"%d\n%d\n%d\n",&Chaoslordlevel,&Chaos,&Chaoslordbehavior);
  filescanstring(fd,Lawlord);
  fscanf(fd,"%d\n%d\n%d\n",&Lawlordlevel,&Law,&Lawlordbehavior);
  filescanstring(fd,Duke);
  fscanf(fd,"%d\n%d\n",&Dukelevel,&Dukebehavior);
  filescanstring(fd,Justiciar);
  fscanf(fd,"%d\n%d\n",&Justiciarlevel,&Justiciarbehavior);
  filescanstring(fd,Commandant);
  fscanf(fd,"%d\n%d\n",&Commandantlevel,&Commandantbehavior);
  filescanstring(fd,Champion);
  fscanf(fd,"%d\n%d\n",&Championlevel,&Championbehavior);
  filescanstring(fd,Archmage);
  fscanf(fd,"%d\n%d\n",&Archmagelevel,&Archmagebehavior);
  filescanstring(fd,Prime);
  fscanf(fd,"%d\n%d\n",&Primelevel,&Primebehavior);
  filescanstring(fd,Shadowlord);
  fscanf(fd,"%d\n%d\n",&Shadowlordlevel,&Shadowlordbehavior);
  for(i=1;i<7;i++) {
    filescanstring(fd,Priest[i]);
    fscanf(fd,"%d\n%d\n",&(Priestlevel[i]),&(Priestbehavior[i]));
  }
  fclose(fd);
  unlock_score_file();
  if (display)
  {
    clear();
#ifndef MSDOS
    printw("High Score: %d",Hiscore);
#else
    printw("High Score: %ld",Hiscore);
#endif
    printw(", by %s (%s)",Hiscorer,levelname(Hilevel));
    printw("\n%s\n",Hidescrip);
    printw("\nLord of Chaos: %s (%s)",Chaoslord,levelname(Chaoslordlevel));
    printw("\nLord of Law: %s (%s)",Lawlord,levelname(Lawlordlevel));
    printw("\n\nDuke of Rampart:              ");
    printw("%s (%s)",Duke,levelname(Dukelevel));
    printw("\nJusticiar:                    ");
    printw("%s (%s)",Justiciar,levelname(Justiciarlevel));
    printw("\nCommandant:                   ");
    printw("%s (%s)",Commandant,levelname(Commandantlevel));
    printw("\nChampion:                     ");
    printw("%s (%s)",Champion,levelname(Championlevel));
    printw("\nArchmage:                     ");
    printw("%s (%s)",Archmage,levelname(Archmagelevel));
    printw("\nPrime Sorceror:               ");
    printw("%s (%s)",Prime,levelname(Primelevel));
    printw("\nShadowlord:                   ");
    printw("%s (%s)",Shadowlord,levelname(Shadowlordlevel));
    printw("\n\nHigh Priests:");
    printw("\n of Odin:                     ");
    printw("%s (%s)",Priest[ODIN],levelname(Priestlevel[ODIN]));
    printw("\n of Set:                      ");
    printw("%s (%s)",Priest[SET],levelname(Priestlevel[SET]));
    printw("\n of Athena:                   ");
    printw("%s (%s)",Priest[ATHENA],levelname(Priestlevel[ATHENA]));
    printw("\n of Hecate:                   ");
    printw("%s (%s)",Priest[HECATE],levelname(Priestlevel[HECATE]));
    printw("\n of the Lords of Destiny:     ");
    printw("%s (%s)",Priest[DESTINY],levelname(Priestlevel[DESTINY]));
    printw("\nThe ArchDruid:                ");
    printw("%s (%s)",Priest[DRUID],levelname(Priestlevel[DRUID]));
    printw("\n\nHit any key to continue.");
    refresh();
    wgetch(stdscr);
  }
}


/* writes a new high score file */
void checkhigh(descrip,behavior)
char *descrip;
int behavior;
{
#ifndef MSDOS
  int i,points;
#else
  int i;
  long points;
#endif
  FILE *fd;

  if (FixedPoints > 0) points = FixedPoints;
  else points = calc_points();

  if (! gamestatusp(CHEATED)) {

    showscores(0); /* load the current high scores... */

    lock_score_file();
    
    strcpy(Str1,OMEGALIB);
    strcat(Str1,"omega.hi");
    fd = checkfopen(Str1,"w");

    if (descrip && Hiscore < points) {

      fprintf(fd,"%s\n",Player.name);
      fprintf(fd,"%s\n",descrip);
#ifndef MSDOS
      fprintf(fd,"%d\n",points);
#else
      fprintf(fd,"%ld\n",points);
#endif
      fprintf(fd,"%d\n",Player.level);
      fprintf(fd,"%d\n",behavior);
    }
    else {
      fprintf(fd,"%s\n",Hiscorer);
      fprintf(fd,"%s\n",Hidescrip);
#ifndef MSDOS
      fprintf(fd,"%d\n",Hiscore);
#else
      fprintf(fd,"%ld\n",Hiscore);
#endif
      fprintf(fd,"%d\n",Hilevel);
      fprintf(fd,"%d\n",Hibehavior);
    }



    if (descrip && Player.alignment < Chaos) {
      fprintf(fd,"%s\n",Player.name);
      fprintf(fd,"%d\n",Player.level);
      fprintf(fd,"%d\n",Player.alignment);
      fprintf(fd,"%d\n",behavior);
    }
    else {
      fprintf(fd,"%s\n",Chaoslord);
      fprintf(fd,"%d\n",Chaoslordlevel);
      fprintf(fd,"%d\n",Chaos);
      fprintf(fd,"%d\n",Chaoslordbehavior);
    }






    if (descrip && Player.alignment > Law) {
      fprintf(fd,"%s\n",Player.name);
      fprintf(fd,"%d\n",Player.level);
      fprintf(fd,"%d\n",Player.alignment);
      fprintf(fd,"%d\n",behavior);
    }
    else {
      fprintf(fd,"%s\n",Lawlord);
      fprintf(fd,"%d\n",Lawlordlevel);
      fprintf(fd,"%d\n",Law);
      fprintf(fd,"%d\n",Lawlordbehavior);
    }




    fprintf(fd,"%s",Duke);
    fprintf(fd,"\n%d",Dukelevel);
    if (Player.rank[NOBILITY] == DUKE && behavior)
      fprintf(fd,"\n%d",behavior);
    else fprintf(fd,"\n%d",Dukebehavior);
    fprintf(fd,"\n%s",Justiciar);
    fprintf(fd,"\n%d",Justiciarlevel);
    if (Player.rank[ORDER] == JUSTICIAR && behavior)
      fprintf(fd,"\n%d",behavior);
    else fprintf(fd,"\n%d",Justiciarbehavior);
    fprintf(fd,"\n%s",Commandant);
    fprintf(fd,"\n%d",Commandantlevel);
    if (Player.rank[LEGION] == COMMANDANT && behavior)
      fprintf(fd,"\n%d",behavior);
    else fprintf(fd,"\n%d",Commandantbehavior);
    fprintf(fd,"\n%s",Champion);
    fprintf(fd,"\n%d",Championlevel);
    if (Player.rank[ARENA] == CHAMPION && behavior)
      fprintf(fd,"\n%d",behavior);
    else fprintf(fd,"\n%d",Championbehavior);
    fprintf(fd,"\n%s",Archmage);
    fprintf(fd,"\n%d",Archmagelevel);
    if (Player.rank[COLLEGE] == ARCHMAGE && behavior)
      fprintf(fd,"\n%d",behavior);
    else fprintf(fd,"\n%d",Archmagebehavior);
    fprintf(fd,"\n%s",Prime);
    fprintf(fd,"\n%d",Primelevel);
    if (Player.rank[CIRCLE] == PRIME && behavior)
      fprintf(fd,"\n%d",behavior);
    else fprintf(fd,"\n%d",Primebehavior);
    fprintf(fd,"\n%s",Shadowlord);
    fprintf(fd,"\n%d",Shadowlordlevel);
    if (Player.rank[THIEVES] == SHADOWLORD && behavior)
      fprintf(fd,"\n%d",behavior);
    else fprintf(fd,"\n%d",Shadowlordbehavior);
    for(i=1;i<7;i++) {
      fprintf(fd,"\n%s",Priest[i]);
      fprintf(fd,"\n%d",Priestlevel[i]);
      if ((Player.rank[PRIESTHOOD] == HIGHPRIEST) && (Player.patron == i) && behavior)
	fprintf(fd,"\n%d",behavior);
      else fprintf(fd,"\n%d",Priestbehavior[i]);
    }
    fprintf(fd,"\n");
    fclose(fd);
    unlock_score_file();

    if (descrip && Hiscore < points) {
	mprint("Yow! A new high score!");
	morewait();
    }
    if (descrip && Player.alignment < Chaos) {
	mprint("Criminy! A new Lord of Chaos!");
	morewait();
    }
    if (descrip && Player.alignment > Law) {
	mprint("Gosh! A new Lord of Law!");
	morewait();
    }
  }
}

void extendlog(descrip,lifestatus)
char *descrip;
int lifestatus;
{
  FILE *fd;
  int npcbehavior;

  if ((Player.level > 0) && (! gamestatusp(CHEATED))) {
    change_to_game_perms();
    npcbehavior=fixnpc(lifestatus);
    checkhigh(descrip,npcbehavior);
    strcpy(Str1,OMEGALIB);
    strcat(Str1,"omega.log");
    fd = checkfopen(Str1,"a");
    fprintf(fd,
	    " %d %d %d %s\n",
	    lifestatus,
	    Player.level,
	    npcbehavior,
	    Player.name);
    fclose(fd);
  }
}





#ifndef MSDOS
/* reads a string from a file. If it is a line with more than 80 char's,
   then remainder of line to \n is consumed */
void filescanstring(fd,fstr)
FILE *fd;
char *fstr;
{
  int i= -1;
  int byte='x';
  while ((i<80) && (byte != '\n') && (byte != EOF)) {
    i++;
    byte=fgetc(fd);
    fstr[i] = byte;
  } 
  if (byte != '\n')
    while((byte!='\n') && (byte != EOF))
      byte=fgetc(fd);
  fstr[i]=0;
}
#endif

#ifdef MSDOS
int test_file_access(char *file_name, char mode)
{
    FILE *fd;

    if (mode == 'r')
	fd = fopen(file_name, "r");
    else
	fd = fopen(file_name, "r+");
    if (!fd)
	return 0;
    fclose(fd);
    return 1;
}
#else
int test_file_access(char *file_name, char mode)
{
    int fd;

    if (mode == 'r')
	fd = open(file_name, O_RDONLY, 0);
    else
	fd = open(file_name, O_RDWR, 0);
    if (fd < 0)
	return 0;
    close(fd);
    return 1;
}
#endif

char *required_file_list[] =
{
  "ocity.dat",
  "ocountry.dat",
  "odlair.dat",
  "omisle.dat",
  "ocourt.dat",
  "ospeak.dat",
  "otemple.dat",
  "oabyss.dat",
#ifdef MSDOS
  "ovillag1.dat",
  "ovillag2.dat",
  "ovillag3.dat",
  "ovillag4.dat",
#else
  "ovillage1.dat",
  "ovillage2.dat",
  "ovillage3.dat",
  "ovillage4.dat",
#endif
  "ohome1.dat",
  "ohome2.dat",
  "ohome3.dat",
  "oarena.dat",
  "omaze1.dat",
  "omaze2.dat",
  "omaze3.dat",
  "omaze4.dat",
  "omega.hi",
  "omega.log",
  "omotd.txt",
  "olicense.txt",
  "ocircle.dat",
  NULL
};

char *optional_file_list[] =
{
  "ohelp1.txt",
  "ohelp2.txt",
  "ohelp3.txt",
  "ohelp4.txt",
  "ohelp5.txt",
  "ohelp6.txt",
  "ohelp7.txt",
  "ohelp8.txt",
  "ohelp9.txt",
  "ohelp10.txt",
  "ohelp11.txt",
  "ohelp12.txt",
  "ohelp13.txt",
  "oabyss.txt",
  "oscroll1.txt",
  "oscroll2.txt",
  "oscroll3.txt",
  "oscroll4.txt",
  NULL
};

/* Checks existence of omega data files */
/* Returns 1 if OK, 0 if impossible to run, -1 if possible but not OK */
int filecheck()
{
    int impossible=FALSE,badbutpossible=FALSE;
    int endpos;
    int file;

    strcpy(Str1, OMEGALIB);
    endpos = strlen(Str1);
    for (file = 0; required_file_list[file]; file++)
    {
	strcpy(&(Str1[endpos]), required_file_list[file]);
	if ((strcmp(required_file_list[file], "omega.hi") == 0 ||
	    strcmp(required_file_list[file], "omega.log") == 0) &&
	    test_file_access(Str1, 'w') == 0)
	{
	    impossible = TRUE;
	    printf("\nError! File not appendable or accessible: %s", Str1);
	}
	else if (test_file_access(Str1, 'r') == 0)
	{
	    impossible = TRUE;
	    printf("\nError! File not accessible: %s", Str1);
	}
    }
    for (file = 0; optional_file_list[file]; file++)
    {
	strcpy(&(Str1[endpos]), optional_file_list[file]);
	if (test_file_access(Str1, 'r') == 0)
	{
	    badbutpossible = TRUE;
	    printf("\nWarning! File not accessible: %s", Str1);
	}
    }
    if (impossible) {
	printf("\nFurther execution is impossible. Sorry.");
	printf("\nOMEGALIB may be badly #defined in odefs.h\n");
	return(0);
    }
    else if (badbutpossible) {
	printf("\nFurther execution may cause anomalous behavior.");
	printf("\nContinue anyhow? [yn] ");
	if (getchar()=='y') return(-1);
	else return(0);
    }
    else return(1);
}

/* display a file given a string name of file */
void displayfile(filestr)
char *filestr;
{
  FILE *fd = checkfopen(filestr,"r");
  int c,d=' ';
  int x,y;
  clear();
  refresh();
  c = fgetc(fd);
  while ((c != EOF)&&((char) d != 'q')&&((char) d!=ESCAPE)) {
    getyx(stdscr,y,x);
    if (y > ScreenLength) { 
      printw("\n-More-");
      refresh();
      d = wgetch(stdscr);
      clear();
    }
    printw("%c",(char) c);
    c = fgetc(fd);
  }
  if (((char) d != 'q')&&((char) d!=ESCAPE)) {
    printw("\n-Done-");
    refresh();
    getch();
  }
  clear();
  refresh();
}    


/* display a file given a string name of file */
void copyfile(srcstr)
char *srcstr;
{
  char deststr[80];
  char cmd[200];
  print1("Enter name of file to create: ");
  strcpy(deststr,msgscanstring());
  strcpy(cmd,"cp ");
  strcat(cmd,srcstr);
  strcat(cmd," ");
  strcat(cmd,deststr);
  print2("Copying file....");
  usersystem(cmd);
  print3("Done.");
}    

